#
#  This example demonstrates how to access the internals
#  of a Numeric array object.
#

cdef extern from "Numeric/arrayobject.h":

  struct PyArray_Descr:
    int type_num, elsize
    char type

  ctypedef class PyArrayObject [type PyArray_Type]:
    cdef char *data
    cdef int nd
    cdef int *dimensions, *strides
    cdef object base
    cdef PyArray_Descr *descr
    cdef int flags

  void import_array()

def print_2d_array(PyArrayObject a):
  print "Type:", a.descr.type

# The Numeric API requires this function to be called before
# using any Numeric facilities in an extension module.
import_array()
